from math import atan2, sqrt, sin, cos, pi

def cross_circ_with_triangl(p0, r0, p1, r1):
	x0 = r0 * cos(p0); y0 = r0 * sin(p0); x1 = r1[-1] * cos(p1[-1]); y1 = r1[-1] * sin(p1[-1])
	w = []
	for i in range(3):
		x2 = r1[i] * cos(p1[i]); y2 = r1[i] * sin(p1[i]); dx = x2 - x1; dy = y2 - y1
		#Определяем пересечение окружности с ребром:
		c = x1 * x1 + y1 * y1 - r0 * r0
		b = 2 * (dx * x1 + dy * y1)
		a = dx * dx + dy * dy
		p = solve_quad_eq(a, b, c)
		for t in p:
			if t < 0 or t > 1: continue
			x = x1 + t * dx
			y = y1 + t * dy
			w.append((x, y))
		x1 = x2; y1 = y2
	#Определяем значения углов относительно нормали:
	for i in range(len(w)):
		dy = - w[i][0] * y0 + w[i][1] * x0; dx = w[i][0] * x0 + w[i][1] * y0
		w[i] = atan2(dy, dx)
	#Переводим углы в нужный диапазон:
	w = [t if t > 0 else 2 * pi + t for t in w]
	w.sort()
	return w

def solve_quad_eq(a, b, c):
	d = b * b - 4 * a * c
	if d < 0: return ()
	d = sqrt(d)
	a = 2 * a
	b = - b
	return ((b - d) / a,
	        (b + d) / a)

fid = open('input.txt', 'r')
dat = list(map(float, fid.read().split()))
p1 = dat[0: 6: 2]; r1 = dat[1: 6: 2]
p2 = dat[6: : 2]; r2 = dat[7: : 2]
wl = 2 * pi
wr = 2 * pi
fl = False
for i in range(3):
	w = cross_circ_with_triangl(
		p2[i], r2[i], p1, r1
	)
	if not w: continue
	zl = 2 * pi - w[-1]
	wl = wl if wl < zl else zl
	zr = w[0]
	wr = wr if wr < zr else zr
	fl = True

ans = wl + wr if fl else 2 * pi

fid = open('output.txt', 'w')
ans = "{0:.5f}".format(ans)
fid.write(ans)
#print(ans)
